//(3)

//the probability P( t, x) : the normal distribution (ave:0 , dev : 2kt)
//Diffusion coefficient k is determined as follows
	//(1) set the probability p
	//(2) record the position at time t
	//(3) the deviatoin of position at time t , & devide by 2t (= V)
	//(4) when drawing V-p graph (horizon:x , vertical:V) -> the slope : k

//t=10 , t=15

#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"dSFMT.h"

#define Number 10000
dsfmt_t dsfmt1;

int main(void){
	int i,j;
	int x;
	double rand;
	double p;
	double V10 = 0.0 , V15 = 0.0;
	int count10[21]={0} , count15[31]={0};
	
	FILE *fp1 , *fp2;
	if( (fp1 = fopen("problem3_4_4_3/expand10.dat","w") )==NULL){
		printf("FILE Error: fp1\n");
		exit(1);
	}
	if( (fp2 = fopen("problem3_4_4_3/expand15.dat","w") )==NULL){
		printf("FILE Error: fp1\n");
		exit(1);
	}
	
	for(p=0.1;p<=0.9;p+=0.1){	//the moving probability p
		
		for(i=0;i<=Number-1;i++){	//the trial number
			dsfmt_init_gen_rand(&dsfmt1,i*p);
			x=0;
			
			for(j=1;j<=20;j++){	//time j
				rand = dsfmt_genrand_close_open(&dsfmt1);
				
				if(rand < p/2.0) 			x += 1;
				else if (rand >= 1 - p/2.0)	x -= 1;
				else 						x  = x;
				
				if(j==10)	count10[x+10] += 1;
				if(j==15)	count15[x+15] += 1;
			}
		}
		
		for(i=0;i<21;i++){	//deviation : t=10
			V10  += pow( (i-10) , 2 )*count10[i]/(double)Number;
			count10[i] = 0;
		}
		for(i=0;i<31;i++){	//deviation : t=15
			V15  += pow( (i-15) , 2 )*count15[i]/(double)Number;
			count15[i] = 0;
		}
	
		fprintf(fp1 ,"%f  %f\n" , p , V10/20.0);
		fprintf(fp2 ,"%f  %f\n" , p , V15/30.0);
		V10 = 0.0;
		V15 = 0.0;
	}
	
	fclose(fp1);
	fclose(fp2);
	return 0;
}
